<template>
    <div>
        <crumbs title="术语医学属性维护">
            <el-form :inline="true" class="demo-form-inline">
                <el-form-item label="医学标准术语：">
                    <el-input size="mini" v-model="filter.termName" placeholder="输入医学标准"></el-input>
                </el-form-item>
                <el-form-item label="术语类型：">
                  <el-select v-model="filter.type" 
                  clearable 
                  filterable 
                  placeholder="请选择" 
                  size="mini">
                    <el-option
                      v-for="item in typeList"
                      :key="item.name"
                      :label="item.name"
                      :value="item.name">
                    </el-option>
                  </el-select>
                </el-form-item>
                <el-form-item>
                    <el-button size="mini" @click="filterDatas">确认</el-button>
                    <el-button size="mini" @click="uploadClick">导入</el-button>
                    <input type="file" name="uploadfile " id="upFile" @change="uploadFile($event)" accept=".csv, application/vnd.ms-excel, application/vnd.openxmlformats-officedocument.spreadsheetml.sheet">
                    <router-link to="/admin/LT-YXSYKWH-TJYXSYXX" style="margin:0 10px">
                        <el-button size="mini" type="warning">添加术语医学属性</el-button>
                    </router-link>
                </el-form-item>
            </el-form>
        </crumbs>
        <div class="contents">
            <el-table :data="list"
                      border
                      style="width: 100%">
                <el-table-column
                        type="index"
                        :index="indexMethod"
                        label="编号"
                        width="60">
                </el-table-column>
                <el-table-column
                        prop="operTime"
                        label="操作时间"
                        :show-overflow-tooltip="true">
                </el-table-column>
                <el-table-column
                        prop="libName"
                        label="医学标准术语"
                        show-overflow-tooltip>
                </el-table-column>
                <el-table-column
                        prop="libType"
                        label="术语类型"
                        show-overflow-tooltip>
                </el-table-column>
                 <el-table-column
                        prop="otherNames"
                        label="同义词"
                        show-overflow-tooltip>
                </el-table-column>
                <el-table-column
                        prop="operName"
                        label="操作人">
                </el-table-column>
                
                <el-table-column
                        label="操作" width="160">
                    <template slot-scope="scope">
                        <el-button type="text" size="small" @click="toEditProduct(scope.row)">修改</el-button>
                        <span style="margin:0 3px;">|</span>
                        <el-button type="text" size="small" class="delete" @click="showDelDialog(scope.row)">删除</el-button>
                    </template>
                </el-table-column>
            </el-table>
            <el-pagination v-if="total>pageSize"
                           :current-page.sync="currentPage"
                           @current-change="currentChange"
                           background
                           :page-size="pageSize"
                           layout="total,prev, pager, next, jumper"
                           :total="total">
            </el-pagination>
        </div>

    </div>
</template>

<script>
  import api from '@api/icss.js';
  export default {
    name: 'MedicalInfo',
    data: function () {
      return {
        list: [],
        cacheData: {},
        currentPage: 1,
        pageSize: 10,
        total: 0,
        filter: {
          termName:'',
          type:''
        },
        typeList:[]
      }
    },
    created() {
      this.getDataList();
      this.getTypeList();
    },
    methods: {
      toEditProduct(row){

        api.getMedicalInfoDetail({medicalId:row.medicalId}).then((res)=>{
          const {code,data,msg} = res.data;
          if(code=='0'){
            const item = Object.assign({},row,data);
            this.$router.push({name:'AddMedicalInfo',params:{isEdit:true,data:item}});
          }else{
            this.$message({
              message: msg,
              type: 'warning'
            });
          }
        });

      },
      filterDatas(){
        this.currentPage = 1;
        this.getDataList();
      },
      getDataList() {
        const param = this.getFilterItems();
        // const param = {
        //   current: this.currentPage,
        //   size: this.pageSize
        // }
        api.getMedicalInfoList(param).then((res) => {
          if (res.data.code == '0') {
            const data = res.data.data;
            this.list = data.records;
            this.cacheData[param.current] = data.records;
            this.total = data.total;
          }
        }).catch((error) => {
          console.log(error);
        });
      },
      getTypeList(){
        api.getAllLexiconRelationship({}).then((res)=>{
          const data = res.data;
          if(data.code==0){
            this.typeList = data.data;
          }else{
            console.log(res.msg);
          }
        }).catch((error) => {
          console.log(error);
        });
      },
      getDetailList(id) {
        const param = {'id': id,};
        // this.$router.push({name:'DeptInfoDetail', params:{id: id}})
      },
      getFilterItems() {
        const param = {
          name: this.filter.termName,
          current: this.currentPage,
          size: this.pageSize,
          type:this.filter.type
        };
        return param;
      },
      indexMethod(index) {
        return ((this.currentPage - 1) * this.pageSize) + index + 1;
      },
      currentChange(next) {
        this.currentPage = next;
        if (this.cacheData[next]) {       //如果已请求过该页数据，则使用缓存不重复请求
          this.list = this.cacheData[next];
        } else {
          this.getDataList();
        }
      },
      warning(msg,type){
        this.$message({
          showClose: true,
          message:msg,
          type:type||'warning'
        })
      },
      showConfirmDialog(msg,resolve){
        this.$alert(msg, '提示', {
          confirmButtonText: '确定',
          type: 'warning'
        }).then(() => {
          resolve();
        }).catch(() => {});
      },
      showDelDialog(row){
        this.showConfirmDialog('是否删除该标准词关联明细，可能对现有系统造成影响；是否删除？',()=>{
          api.removeMedicalInfo({medicalId: row.medicalId}).then((res)=>{
            if(res.data.code=='0'){
              this.warning(res.data.msg||'操作成功','success');
              this.getDataList();
            }else{
              this.warning(res.data.msg);
            }
          }).catch((error)=>{
            this.warning(error);
          })
        });
      },
      uploadClick(){
        let inp = document.getElementById("upFile");
        inp.click();
      },
      uploadFile(e){
        let fileInfo = e.target.files[0];
        e.preventDefault();
        let formData = new FormData();
        formData.append('uploadfile', fileInfo);
        console.log(123,fileInfo,formData);
        const header = {
          headers:{
            'Content-Type': 'multipart/form-data'
          }
        }
        api.medicalInfoExcelIm(formData,header).then((res)=>{
          if(res.data.code==0){
            this.$message({
              message: '上传成功',
              type: 'success',
            });
          }else{
            this.$message({
              message:res.data.msg,
              type:'warning'
            });
          }
        })
        this.getDataList();
        //解决上传相同文件不触发change
        let inp = document.getElementById("upFile");
        inp.value = "";
        
      },
    }
  }
</script>

<style lang="less" scoped>
    @import "../../less/admin.less";
    .delete{
        color: red;
    }
    .el-table .cell{
      overflow: hidden;
      white-space: nowrap;
    }
    #upFile{
      display: none !important;
    }
</style>